#include <windows.h>
#include <stdlib.h>

#include "hashlib.h"

// Read a file
// Returns  a pointer to a buffer that must be freed if successful
// NULL is returned on failure.
char *GetFile(char* strzFileName, char** strRetBuff, DWORD *nRetSize)
{
	*strRetBuff = 0;
	*nRetSize = 0;

	// Open the file
	HANDLE hFile = 
		CreateFile(strzFileName, 
			GENERIC_READ, 
			FILE_SHARE_READ | FILE_SHARE_WRITE, 
			NULL, 
			OPEN_EXISTING, 
			FILE_FLAG_SEQUENTIAL_SCAN, 
			NULL);
	
	if(hFile == INVALID_HANDLE_VALUE)
		return NULL;

	// Determine size and allocate buffer
	DWORD nSize;
	char *strBuff;
	nSize = GetFileSize(hFile, NULL);
	if(nSize == 0xffffffff) {
		CloseHandle(hFile);
		return NULL;
	}
	if( (strBuff = (char *)malloc((size_t)nSize)) == NULL) {
		CloseHandle(hFile);
		return NULL;
	}

	// Position file pointer
	if(SetFilePointer(hFile, 0, 0, FILE_BEGIN) != 0) {
		free(strBuff);
		CloseHandle(hFile);
		return NULL;
	}

	// Read the file
	if(ReadFile(hFile, strBuff, nSize, &nSize, NULL) == 0)
	{
		free(strBuff);
		CloseHandle(hFile);
		return NULL;
	}

	// Close the file
	CloseHandle(hFile);

	// Return
	*strRetBuff = strBuff;
	*nRetSize = nSize;
	return strBuff;
}

/*
void EncryptHashKey(unsigned char *buff)
{
	// Perform basic encryption
	unsigned char xor_mask[16] = 
		{59, 72, 17, 157, 216, 85, 245, 225, 65, 216, 180, 182, 81, 154, 173, 203};
	unsigned char shuffle_index[16] = 
		{6, 4, 1, 12, 14, 0, 9, 8, 2, 5, 7, 11, 13, 3, 10, 15};
	char temp_buff[16];

	// xor
	int x;
	for(x = 0; x < 16; x++)
		temp_buff[x] = buff[x] ^ xor_mask[x];

	// shuffle
	for(x = 0; x < 16; x++)
		buff[x] = temp_buff[shuffle_index[x]];
}

void ReadHashKey(unsigned char *strHash, char *strBuff)
{
	// Convert hash key from hex to binary
	int i, v; unsigned char c;
	for(i = 0; i < 32; i++)
	{
		c = strBuff[31 - i];
		if(c >= '0' && c <= '9') 
			v = c - '0';
		else if(c >= 'a' && c <= 'f')
			v = c - 'a' + 10;
		else if(c >= 'A' && c <= 'F')
			v = c - 'A' + 10;
		else
			v = 0;

		if(i & 1) {
			strHash[i>>1] &= 0x0F;
			strHash[i>>1] |= (v << 4);
		} else {
			strHash[i>>1] &= 0xF0;
			strHash[i>>1] |= v;
		}
	}
}

*/
  // end